淘先锋技术网

首页 1 2 3 4 5 6 7

Leetcode 学习之路 039 组合总和

题目描述

        给定一个无重复元素的数组 candidates 和一个目标数 target ,找出 candidates 中所有可以使数字和为 target 的组合。

candidates 中的数字可以无限制重复被选取。

说明:

所有数字(包括 target)都是正整数。
解集不能包含重复的组合。

输入:candidates = [2,3,6,7], target = 7,
所求解集为:
[
[7],
[2,2,3]
]

输入:candidates = [2,3,5], target = 8,
所求解集为:
[
[2,2,2,2],
[2,3,3],
[3,5]
]

一、解题思路

       这道题如果采用遍历循环的方式时间复杂度很高,因此,通过回溯的方法可以较快的解决问题。回溯适用于备选可能的情况有很多的题目,如果使用遍历的方法时间复杂度为n的指数次幂。
       回溯过程中维护一个存储空间(数组、字符串等),表示已有的元素排列。该存储空间初始为空。每次从题目给出的元素集合中取一个元素,将其放在临时存储空间中,当临时空间满足终止条件(长度、求和等)就进行回退操作。

二、JAVA实现

class Solution {
    public List<List<Integer>> combinationSum(int[] candidates, int target) {
        List<List<Integer>> result=new ArrayList<List<Integer>>();

        backcombinationSum(result,candidates,0,target,new ArrayList<Integer>());

        return result;
    }
    public void backcombinationSum( List<List<Integer>> result, int[] candidates,int index,int target,List<Integer> temp){
        if (sumList(temp)==target) {
            result.add(new ArrayList<Integer>(temp));
            return;
        }
        else if (sumList(temp)>target)
            return;
        else {
            for (int i=index;i<candidates.length;i++){
                temp.add(candidates[i]);
                index=i;
                backcombinationSum(result,candidates,index,target,temp);
                temp.remove(temp.size()-1);
            }
            
        }


    }
    public int sumList(List<Integer> temp){
        int sum=0;
        for (int i:temp)
            sum=sum+i;
        
        return sum;
    }
}

总结

       这次题目的实现并不理想,因为在回溯函数的elseif判断后还会进行额外的计算,具体优化的方式可以参照leetcode的官方题解。